<?php
session_name("prolawyer");
session_start();
require_once("./inc/autoload.php");
error_reporting(127);
$doc=new prolawyer;
// $doc->tab_affiche();



/*AFFICHAGE DES critères
*
*
*/

//Affichage: suivipar
$couleur = array("ff8080", "80ff80", "8080ff", "80ffff", "ff80ff", "ffff80");
$coulCol = array();

//Affichage: état du dossier
# inutile, automatique dans prolawyer() if(! isset($_POST["nom_client"]) && isset($_GET["nom_client"])) $_POST["nom_client"] = $_GET["nom_client"];
$etat = array(array("ffffff", "actif"), array("4040ff", "dormant"), array("ffff00", "attente_paiement"), array("ff8000", "attente_archivage"), array("808080", "a_boucler"), array("ff0000", "archive"));
if($_POST["tousDormants"]) foreach ($etat as $num =>$arr) $_POST["dormant"][] = $num;
$dm = "<select size=6 multiple name='dormant[]'>";
$dormant = ($_POST["dormant"] && is_array($_POST["dormant"])) ? $_POST["dormant"]:array(0);
$affiche_dormant = "";
$sleepColors=array();
foreach($etat as $n => $st)
{
	$noun = $st[1];
	$colo = $st[0];
	$sleepColors[] = $colo;
	$nom_dormant = $doc->lang["modifier_donnees_$noun"];
	if (in_array($n, $dormant)) 
	{
		if($affiche_dormant) $affiche_dormant .= ", ";
		$affiche_dormant .= "<span style='background-color:#$colo'>{$doc->lang["modifier_donnees_$noun"]}</span>";
	}
	$selected = (in_array($n, $dormant)) ? "selected":"";
	$dm .=  "<option style='background-color:#ffffff' value='$n' $selected>$nom_dormant</option>";
}
$dm .= "</select>";

$debut_mysql = ($_POST["debut"] <> "") ? $_POST["debut"] : "0";
$critere_nom = ($_POST["client"]) ? $_POST["client"] : ($resultat_recherche_nocritere);
$critere_nom_pa = ($_POST["pa"]) ? $_POST["pa"] : ($resultat_recherche_nocritere);
$critere_naturemandat = ($_POST["naturemandat"]) ? $_POST["naturemandat"] : ($resultat_recherche_nocritere);
$critere_nodossier = ($_POST["nodossier"]) ? $_POST["nodossier"] : ($resultat_recherche_nocritere);
$critere_noarchive = ($_POST["noarchive"]) ? $_POST["noarchive"] : ($resultat_recherche_nocritere);
$critere_dormant = ($_POST["dormant"]) ? $affiche_dormant : ($resultat_recherche_nocritere);
$dossier = ($_POST["nodossier"] == "") ? "%" : $_POST["nodossier"];
$archive = ($_POST["noarchive"] == "") ? "%" : $_POST["noarchive"];
$_POST["nom_client"]=strtolower($_POST["nom_client"]); //pour éviter les problèmes liés à la casse
$_POST["nom_pa"]=strtolower($_POST["nom_pa"]); //pour éviter les problèmes liés à la casse
$_POST["naturemandat"]=strtolower($_POST["naturemandat"]); //pour éviter les problèmes liés à la casse


$numofrow = 0;
$resRecherche = "";
if($_POST["doRecherche"])
{
	/*CONDITIONS (critères de recherche
	*
	*
	*/

	$requis = array();
	$condit = array();
	// $ajoute = array();

	//Condition: Nom client et nom PA
	$newReq = "";
	$newWhr = "";
	$leftJn = "";
	$parts = array();
	foreach(array("client" => "noadresse", "pa" => "nopa") as $type => $clId)
	{
		//construction des champs	
		for($x = "";$x <5;$x++)
		{
			foreach(array("prenom", "nom", "fonction", "adresse", "zip", "ville", "id") as $champ)
			{
				if ($newReq) $newReq .= ", ";
				$newReq .= "a{$type}{$x}.$champ as {$champ}_$type{$x}";
			}
			if($leftJn) $leftJn .= " ";
			$leftJn .= "LEFT JOIN adresses a{$type}{$x} on a.{$clId}{$x}= a{$type}{$x}.id";
		}
		
		//construction de la requête
		if($_POST["$type"])
		{
			$rType = "";
			for($x = "";$x <5;$x++)
			{
				$rNum = "";
				$parts["$type"] = explode(" ", $_POST["$type"]);
				foreach($parts["$type"] as $i => $part)
				{
					$part = trim($part);
					if($part)
					{
						if($rNum) $rNum .= " AND ";
						$rPart = "";
						foreach(array("prenom", "nom", "fonction", "adresse", "zip", "ville", "id") as $champ)
						{
							if($rPart) $rPart .= " OR ";
							$protectPart = addslashes(stripslashes($part));
							$rPart .= "a{$type}{$x}.$champ like '%$protectPart%'";
						}
						$rNum .= "($rPart)";
					}
				}
				if($rType) $rType .= " OR ";
				$rType .= "($rNum)";
			}
			$condit["$type"] = "$rType";
			$requis[] = "$type";
		}
	}



	// echo "<br><br>$newWhr + " . strlen("@");
	// echo beautifyMysql($condit["client"]);
	// echo beautifyMysql($condit["pa"]);

	//Condition: Nature du dossier
	$condNature = "";
	if($_POST["naturemandat"])
	{
		$parts["naturemandat"]  = explode(" ", $_POST["naturemandat"]);
		foreach($parts["naturemandat"] as $part) if(trim($part) != "")
		{
			if($condNature) $condNature .= " AND ";
			$condNature .= "naturemandat like '%$part%'"; 
		}
	}
	$condit["naturemandat"] = "$condNature";

	//Condition: Suivi par
	$condit["suivipar"] = "suivipar like '%{$_POST["suivipar"]}%'";

	//Condition: Type
	if($dormant)
	{
		$c = "";
		$t = 0;
		foreach($dormant as $dormeur)
		{
			if($t) $c .= " or ";
			$t ++;
			if($dormeur == -1)
			{
				$c .= "(noarchive = 0 AND dormant = 0)";
			}
			elseif($dormeur < 5)
			{
				$c .= "(noarchive = 0 AND dormant = $dormeur)";
			}
			else
			{
				$c .= "noarchive > 0";

			}
		}
		if($c) $condit["dormant"] = "$c";
	}


	//Condition: N° du dossier / N° d'archive
	foreach(array("nodossier", "noarchive") as $trait)
	{
		$var = $_POST[$trait];
		$var = trim($var);
		$var = preg_replace("# #", "", $var);
		if($var != "")
		{
			if(preg_match("#-#", $var))
			{
				$var = preg_replace("#-#", "' AND '", $var);
				$var = "$trait BETWEEN '$var'";
			}else{
				$var = "$trait = '$var'";
			}
		}else{
			$var="";
		}
		$condit["$trait"] = $var;
	}

	//Autres conditions (en réalité: champs supplémentaires
	$condit["datearchivage"] = "";
	for($x = "";$x<5;$x++) foreach(array("noadresse", "nopa") as $no) $condit["{$no}{$x}"] = "";


	/*Construction de la requete
	*
	*
	*/

	//Requête: Where
	$where = "";
	foreach($condit as $nom => $val)
	{
		if($val)
		{
			$where .= $where? " AND ": "WHERE ";
			$where .= "($val)";
		}
		if(!in_array($nom, $requis))
		{
			if($newReq) $newReq .= ", ";
			$newReq .= $nom;
		}
	}

	//Requête: Order By
	$_POST["orderby"] = ($_POST["orderby"])? $_POST["orderby"]:"nodossier";
	$doorderby=$_POST["orderby"];

	//Requête: Sort
	$sortType = $_POST["sort"]? $_POST["sort"]: "ASC";


	//Requête finale:
	$qStop = "SELECT $newReq FROM {$_SESSION["session_avdb"]} a $leftJn $where";// limit $debut_mysql, {$_SESSION["nb_affiche"]}";
	$query = "SELECT $newReq FROM {$_SESSION["session_avdb"]} a $leftJn $where ORDER BY $doorderby $sortType limit $debut_mysql, {$_SESSION["nb_affiche"]}";

	$resRecherche .= "{$doc->lang["resultat_recherche_criteres"]}:<br>";
	if($critere_nom) $resRecherche .= "<br>{$doc->lang["resultat_recherche_nom"]} :  <b>$critere_nom</b>";
	if($critere_nom_pa) $resRecherche .= "<br>{$doc->lang["resultat_recherche_nom_pa"]} :  <b>$critere_nom_pa</b>";
	if($critere_naturemandat) $resRecherche .= "<br>{$doc->lang["resultat_recherche_nature"]} :  <b>$critere_naturemandat</b>";
	if($critere_nodossier) $resRecherche .= "<br>{$doc->lang["resultat_recherche_nodossier"]} :  <b>$critere_nodossier</b>";
	if($critere_noarchive) $resRecherche .= "<br>{$doc->lang["resultat_recherche_noarchive"]} :  <b>$critere_noarchive</b>";
	if($critere_dormant) $resRecherche .= "<br>{$doc->lang["modifier_donnees_typedossier"]} :  <b>$critere_dormant</b>";
	
	$resulStop  = mysqli_query($doc->mysqli, $qStop);
	$stop_mysql = mysqli_num_rows($resulStop);
	$numofrow   = $stop_mysql;
	
	$resultats = mysqli_query($doc->mysqli, $query);
	if($numofrow > 0)
	{
		$resRecherche .= "\n<br>";
		$resRecherche .= $doc->table_open("border=1 width=\"100%\" align=\"left\"");
		$compt = 0;
		$formcompt = 0;
		if($numofrow > 1) $affiche_result="{$doc->lang["resultat_recherche_records"]}";
		else $affiche_result="{$doc->lang["resultat_recherche_record"]}";
		
		//on décrit les enregistrements trouvés
		$resRecherche .= "\n<br><br><br>{$doc->lang["resultat_recherche_trouves"]} $numofrow $affiche_result :<br><br>
		<tr>";
		$resRecherche .= "<th><a onClick='changeAcc()' accesskey=z>+</a></th>";
		foreach(array("nodossier" => $doc->lang["resultat_recherche_nodossier"], "noarchive" => $doc->lang["resultat_recherche_noarchive"]."<br>({$doc->lang["modifier_donnees_date_archivage"]})", "nom_client" => $doc->lang["resultat_recherche_coordonnees"],"naturemandat" => $doc->lang["resultat_recherche_nature"], "nom_pa" => $doc->lang["resultat_recherche_pa"], "suivipar" => $doc->lang["modifier_donnees_suivi"]) as $orderby => $design)
		{
			$iName = strtolower($sortType);
			$counterSort = ($_POST["sort"] == "ASC")?"DESC":"ASC";
			$class = ($orderby != $_POST["orderby"])? "":"class=\"attention\"";
			$image = ($orderby != $_POST["orderby"])? "":"&nbsp;<img src=\"{$doc->settings["root"]}images/$iName.png\">";
			$resRecherche .= "<th><form action = ./resultat_recherche.php method=POST style='display:inline'><button type=submit $class>$design</button>$image";
			foreach($_POST as $nom => $val)
			{
				if(!in_array($nom, array("sort", "dormant"))) $resRecherche .= ($nom != "orderby")? $doc->input_hidden($nom, 1):$doc->input_hidden("orderby", "", $orderby);
				if($nom == "dormant") foreach($_POST["dormant"] as $d =>$dV) $resRecherche .= $doc->input_hidden("dormant[]", "", $dV);
			}
			$resRecherche .= ($orderby != $_POST["orderby"])? $doc->input_hidden("sort", "", "ASC"): $doc->input_hidden("sort", "", "$counterSort");
			$resRecherche .= "</form></th>";
		}
		$resRecherche .= "<th>{$doc->lang["resultat_recherche_action"]}</th>
		</tr>";
		while($row=mysqli_fetch_array($resultats))
		{
			$compt ++;
			$comptname="form".$compt;
			if($compt<10) $accesskey=$compt;
			elseif($compt == 10) $accesskey=0;
			else $accesskey = NULL;
			if(!$row["noarchive"]) $row["noarchive"]="";//évite l'affichage d'un numéro inexistant par 0
			if($compt<11) $no_compt="$compt";
			else $no_compt="&nbsp;";
			if($row["datearchivage"]>0)
			{
					$class="class=\"attention_bg\"";
					$row["noarchive"] .= "<br>(".$doc->mysql_to_print($row["datearchivage"]).")";
			}
			else
			{
				$class="";
			}
			if($row["dormant"])
			{
				$dormeur = $row["dormant"];
				$class2="style='background-color:#{$sleepColors[$dormeur]}'";
			}
			else $class2="";
			$resRecherche .= "\n<tr><td>$no_compt&nbsp;</td>";
			$resRecherche .= "<td $class2>{$row["nodossier"]}&nbsp;</td>";
			$resRecherche .= "<td $class>{$row["noarchive"]}&nbsp;</td>";
			foreach(array("client" => "noadresse", "pa" => "nopa") as $typePers => $champPers)
			{
				$pers = "";
				for($x="";$x<5;$x++)
				{
					$champTest = "{$champPers}{$x}";
					$comp=$champPers.$x;
					$id=$row[$comp] ? $row[$comp]:"";
					if($id)
					{
						$chain="";
						$chainChamps = array();
						foreach(array("prenom", "nom", "fonction", "adresse", "zip", "ville") as $champ)
						{
							$$champ = "";
							$champrow = "{$champ}_{$typePers}{$x}";
							$aff = trim($row["$champrow"]);
							if(trim($aff) != "") $$champ = $aff;
							if(is_array($parts[$typePers])) $$champ = $doc->make_visible($parts[$typePers], $$champ);
						}
						if($nom) $nom = "<b>$nom</b>";
						if(!$zip) $zip = "";
						if($nom && $prenom) $nom = "$prenom $nom";
						elseif($prenom) $nom = $prenom;
						if($zip && $ville) $ville = "$zip $ville";
						foreach(array("nom", "fonction", "adresse", "ville") as $champ) if($$champ)
						{
							if($chain) $chain .= ", ";
							$chain .=  $$champ;
							$formcompt ++;
						}
						$pers .= "\n<tr><td style=\"cursor:pointer\" onClick=\"document.getElementById('fcompt$formcompt').submit();\">$chain ($id)</td>";
						$pers .= $doc->form("adresses/modifier.php<td>", "", "", "", "fcompt$formcompt<td>", "id", $id);
						$pers .= "</tr>";
					}
				}
				$pers = "<table>$pers</table>";
				$affPers["$typePers"] = $pers;
			}
			$resRecherche .= "<td>{$affPers["client"]}</td>";
			if(is_array($parts["naturemandat"])) $row["naturemandat"] = $doc->make_visible($parts["naturemandat"], $row["naturemandat"]);
			$resRecherche .= "<td>{$row["naturemandat"]}&nbsp;</td>";
			if($row["suivipar"])
			{
				$suiveur = $row["suivipar"];
				if(!array_key_exists($suiveur, $coulCol))
				{
					$indice = count($coulCol);
					$actCoul = $couleur[$indice];
					$coulCol[$suiveur] = $actCoul;
				}
				$suiveur = "<span style='background-color:#{$coulCol["$suiveur"]}'>$suiveur</span>";
			}
			else $suiveur = "";
// 			$resRecherche .= "<td>$pers&nbsp;<a href=# onclick=\"window.open('{$doc->settings["root"]}liste_soldes.php?clientReq={$row["nodossier"]}','modifier','scrollbars=yes,width=600,height=600,toolbar=no,directories=no,menubar=no,location=no,status=no')\">{$doc->lang["multi_clients_title"]}</a></td>";
			$resRecherche .= "<td>{$affPers["pa"]}&nbsp;<a href=# onclick=\"window.open('{$doc->settings["root"]}liste_soldes.php?clientReq={$row["nodossier"]}','modifier','scrollbars=yes,width=600,height=600,toolbar=no,directories=no,menubar=no,location=no,status=no')\">{$doc->lang["multi_clients_title"]}</a></td>";
			//$resRecherche .= "<td>{$row["suivipar"]}</td>";
			$resRecherche .= "<td>$suiveur</td>";
			$resRecherche .= "<td><table cellspacing=0 cellpadding=0><tr><td>";
			$resRecherche .= $doc->form("operations.php", "<img src='images/operations.png'>", $accesskey, "accyes", "1-$comptname<td>", "nodossier", $row["nodossier"]);
			$resRecherche .= "</td><td>";
			$resRecherche .= $doc->form("operations.php", "<img src='images/encaissements.png'>", "", "accno", "2-$comptname<td>", "nodossier", $row["nodossier"], "secteur", "encaissements");
			$resRecherche .= "</td><td>";
			$resRecherche .= $doc->form("modifier_donnees.php", "<img src='images/modifier.png'>", "", "accno", "3-$comptname<td>", "nodossier", $row["nodossier"]);
			$resRecherche .= "</td><td>";
			if ($row["chemin"]) $resRecherche .= "<a href='file://{$row["chemin"]}' target='4-$comptname'><img src='images/folder.png'></a>";
			$resRecherche .= "</td></tr></table></td></tr>";
		}
		$resRecherche .= $doc->table_close();
	}else {       // S'il n'y a rien qui correspond aux critères, on le dit.
		$resRecherche .= "<br><br><table align=left border=\"0\" width=\"100%\">
		<tr><td>{$doc->lang["resultat_recherche_rien_trouve"]}.</td></tr>";
		$resRecherche .= "</table></td></tr>";
	}
	//Dans les deux cas, on peut effectuer une nouvelle recherche
	
	$checked = $_POST["plusarchive"] ? "checked":"";
	$resRecherche .= "<tr><td>";
	$resRecherche .= "<br>";
}

$fname=($numofrow)?"form":"1-form1";//Affichage de la page
$fnnum=($numofrow)?"1":"0";//Affichage de la page
if(! $_POST["doRecherche"]) $doc->title_name = $doc->lang["recherche_dossier_title"];
$doc->title();
$doc->body("2", "document.getElementById('1-form1').elements[$fnnum].focus()");
$doc->entete();
// echo $doc->beautifyMysql($query);



if($_POST["doRecherche"])
{
	echo "<br>$resRecherche<br>";
	if($numofrow>0 AND !$stop) $doc->footer();
	echo "<br>{$doc->lang["resultat_recherche_nouvelle"]}<br>";
}
else echo "\n<h1>{$doc->lang["recherche_dossier_title"]}</h1><h2>({$doc->lang["entete_base_en_cours"]} : {$doc->avocat})</h2>";


$checkAll = $doc->input_checkbox("tousDormants", True);
$suivi=$doc->simple_selecteur("", $_POST["suivipar"]);


echo "
<br><form name=\"$fname\" id=\"$fname\" method=post action=\"./resultat_recherche.php\">
<table style=\"white-space:nowrap\">
<tr>
<td width=\"100\">{$doc->lang["recherche_dossier_nom"]} :</td><td><input type=texte name=\"client\" value=\"{$_POST["client"]}\" onfocus=select()></td>
</tr>
<tr>
<td width=\"100\">{$doc->lang["recherche_dossier_nom_pa"]} :</td><td><input type=texte name=\"pa\" value=\"{$_POST["pa"]}\" onfocus=select()></td>
</tr>
<tr>
<td>{$doc->lang["resultat_recherche_nature"]}&nbsp;:</td><td><input type=text name=\"naturemandat\" value=\"{$_POST["naturemandat"]}\" onfocus=select()></td>
</tr>
<tr>
<td>{$doc->lang["resultat_recherche_nodossier"]} :</td><td><input type=texte name=\"nodossier\" value=\"{$_POST["nodossier"]}\" onfocus=select()></td>
</tr>
<tr>
<td>{$doc->lang["resultat_recherche_noarchive"]} :</td><td><input type=texte name=\"noarchive\" value=\"{$_POST["noarchive"]}\" onfocus=select()></td>
</tr>
<tr>
<td>{$doc->lang["modifier_donnees_suivi"]} :</td><td><select name=suivipar>$suivi</select></td>
</tr>
<tr>
<td>{$doc->lang["modifier_donnees_typedossier"]}&nbsp;:</td><td>{$doc->lang["general_tous"]} $checkAll<br>$dm</td>
</tr>";
/*echo "<tr>
<td>{$doc->lang["liste_soldes_y_compris"]}&nbsp;</td><td><input type=checkbox name=plusarchive $checked></td>
</tr>";*/
echo "</table>
<input type=hidden name=doRecherche value=on>
<input type=submit value=\"{$doc->lang["recherche_dossier_recherche"]}\">
</form>";


$doc->close();	
 ?>
